type ('k, 'v) map =
    Empty
  | Node of ('k, 'v) map * 'k * 'v * ('k, 'v) map

let create () = Empty

let rec add k v m =
  match m with
  | Empty -> Node(Empty, k, v, Empty)
  | Node(fg, k', v', fd) ->
     if k < k'
     then Node(add k v fg, k', v', fd)
     else if k > k'
     then Node(fg, k', v', add k v fd)
     else Node(fg, k, v, fd)
     
let rec find k m =
  match m with
  | Empty -> raise Not_found
  | Node(fg, k', v', fd) ->
     if k < k'
     then find k fg
     else if k > k'
     then find k fd
     else v'


let rec remove_rightmost m =
  match m with
    Empty -> assert false
  | Node(fg, k, v, Empty) -> fg, k, v
  | Node(fg, k, v, fd) ->
     let fd', k', v' = remove_rightmost fd in
     Node(fg, k, v, fd'), k', v'
       
let remove_root m =
  match m with
    Empty -> assert false
  | Node(Empty, _, _, fd) -> fd
  | Node(fg, _, _, Empty) -> fg
  | Node(fg, _, _, fd) ->
     let fg', k, v = remove_rightmost fg in
     Node(fg', k, v, fd)
     
     
       
let rec remove k m =
  match m with
  | Empty -> Empty
  | Node(fg, k', v', fd) ->
     if k < k'
     then Node(remove k fg, k', v', fd)
     else if k > k'
     then Node(fg, k', v', remove k fd)
     else remove_root m
